module top
  (
   input        clk,
   output [2:0] led,
   input        reset_n
   );

  // counter
  reg [31:0] counter = 0;
  assign led = ~counter[25:23];

  always @(posedge clk)
    begin
      if (reset == 1'b1)
        begin
          counter <= 1'd0;
        end
      else
        begin
          counter <= counter + 1'd1;
        end
    end

  // generate reset signal
  wire           reset;
  reg            reset_reg1;
  reg            reset_reg2;
  assign reset = reset_reg2;

  always @(posedge clk)
    begin
      reset_reg1 <= ~reset_n;
      reset_reg2 <= reset_reg1;
    end

endmodule
